/*********************************************************************NVMH3****
File:  $Id: //sw/devtools/SDK/9.5/SDK/MEDIA/HLSL/pre_noise3d.fx#3 $

Copyright NVIDIA Corporation 2004
TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED
*AS IS* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL NVIDIA OR ITS SUPPLIERS
BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES
WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS,
BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS)
ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS
BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


Comments:
    Put a texture behind the current scene
	Geometry Ignored

******************************************************************************/

#include <include\\Quad.fxh>

#define NOISE_SCALE 2

#include <include\\noise_3d.fxh>

float Script : STANDARDSGLOBAL <
	string UIWidget = "none";
	string ScriptClass = "scene";
	string ScriptOrder = "preprocess";
	string ScriptOutput = "color";
	string Script = "Technique=TexBg;";
> = 0.8; // version #

float ClearDepth <string UIWidget = "none";> = 1.0;

float Timer:TIME <string UIWidget = "none";>;

float Speed <
	string UIWidget = "slider";
	float UIMin = 0.000001;
	float UIMax = 2;
	float UIStep = 0.000001;
> = 0.3;

static float Anim = (Timer*Speed);
static float Anim2 = ((Timer+.5)*Speed);
static float Mix = (0.5*(cos(Anim*4.0*3.141592653589)+1.0));

////

struct SolidVertexOutput {
   	QUAD_REAL4 Position	: POSITION;
    QUAD_REAL3 UV		: TEXCOORD0;
    QUAD_REAL3 UV2		: TEXCOORD1;
};

SolidVertexOutput ScreenSolidVS(
		QUAD_REAL3 Position : POSITION, 
		QUAD_REAL3 TexCoord : TEXCOORD0
) {
    SolidVertexOutput OUT;
    OUT.Position = QUAD_REAL4(Position, 1);
#ifdef NO_TEXEL_OFFSET
    OUT.UV = TexCoord.xy;
#else /* NO_TEXEL_OFFSET */
	QUAD_REAL2 off = QUAD_REAL2(QuadTexOffset/(QuadScreenSize.x),QuadTexOffset/(QuadScreenSize.y));
    OUT.UV = QUAD_REAL3((TexCoord.xy+off),Anim); 
    OUT.UV2 = QUAD_REAL3((TexCoord.xy+off),Anim2); 
#endif /* NO_TEXEL_OFFSET */
    return OUT;
}

QUAD_REAL4 TexSolidPS(SolidVertexOutput IN,uniform sampler3D InputSampler) : COLOR
{   
	QUAD_REAL4 texCol = tex3D(InputSampler, IN.UV);
	QUAD_REAL4 texCol2 = tex3D(InputSampler, IN.UV2);
	return lerp(texCol,texCol2,Mix);
}  

///////// Textures ///////////////

technique TexBg <
	string Script =
				"ClearSetDepth=ClearDepth;"
				"Clear=Depth;"
				"Pass=Bg;"
				"ScriptExternal=Scene;";
> {
	pass Bg <
		string Script = "Draw=Buffer;";
	> {
		VertexShader = compile vs_1_1 ScreenSolidVS();
		AlphaBlendEnable = false;
		ZEnable = false;
		PixelShader  = compile ps_2_a TexSolidPS(NoiseSamp);
	}
}

/***************************** eof ***/
